%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear;
constants;

cluster_range = (CLUSTERING_SIZE_MAX-CLUSTERING_SIZE_MIN)/CLUSTERING_SIZE_INT + 1;
average_purity = zeros(cluster_range,1);
average_randIndex = zeros(cluster_range,1);
average_recall = zeros(cluster_range,1);
average_precision = zeros(cluster_range,1);

build_all_folder;

purity = [];
randIndex = [];
recall = [];
precision = [];
for c=CLUSTERING_SIZE_MIN:CLUSTERING_SIZE_INT:CLUSTERING_SIZE_MAX
	disp( strcat('cluster size', 32, int2str(c), ' ...') );

	training_cluster_path = strcat(all_cluster_data_folder, 'c', int2str(c), '_training.txt');
	training_IDX = load(training_cluster_path);

	%% compute Purity
	cluster_event_type_count = zeros(c, length(unique_labels));
	for i=1:length(compressed_training_window_labels)
		tidx = training_IDX(i);
		cet = compressed_training_window_labels(i);
		cluster_event_type_count(tidx, cet) = cluster_event_type_count(tidx, cet) + 1;
	end
	purity = [purity; sum(max(cluster_event_type_count, [], 2)) / length(compressed_training_window_labels)];

	%% compute Rand Index, Recall and Precision		
	event_types = compressed_training_window_labels;
	TP = 0;
	TN = 0;
	FN = 0;
	FP = 0;
	for i=1:length(event_types)
		for j=i+1:length(event_types)
			if event_types(i) == event_types(j)
				if training_IDX(i) == training_IDX(j)
					TP = TP + 1;
				else
					FN = FN + 1;
				end
			else
				if training_IDX(i) == training_IDX(j)
					FP = FP + 1;
				else
					TN = TN + 1;
				end
			end
		end
	end
	randIndex = [randIndex; (TP + TN) / (TP+TN+FP+FN)];
	precision = [precision; TP / (TP + FP)];
	recall = [recall; TP / (TP + FN)];		
end

save(strcat(all_clustering_results_folder, 'purity.txt'), 'purity', '-ASCII', '-tabs');
save(strcat(all_clustering_results_folder, 'randIndex.txt'), 'randIndex', '-ASCII', '-tabs');
save(strcat(all_clustering_results_folder, 'recall.txt'), 'recall', '-ASCII', '-tabs');
save(strcat(all_clustering_results_folder, 'precision.txt'), 'precision', '-ASCII', '-tabs');

