%%
all_raw_data_folder = strcat(RAW_DATA_FOLDER, 'all', '/');
all_fft_data_folder = strcat(FFT_DATA_FOLDER, 'all', '/');
all_reduced_fft_data_folder = strcat(REDUCED_FFT_DATA_FOLDER, 'all', '/');
all_cluster_data_folder = strcat(CLUSTER_DATA_FOLDER, 'all', '/');
all_lda_data_folder = strcat(LDA_DATA_FOLDER, 'all', '/');
all_classification_results_folder = strcat(CLASSIFICATION_RESULTS_FOLDER, 'all', '/');
all_clustering_results_folder = strcat(CLUSTERING_RESULTS_FOLDER, 'all', '/');
all_lda_results_folder = strcat(LDA_RESULTS_FOLDER, 'all', '/');

if DO_MKDIR
	mkdir(all_reduced_fft_data_folder);
	mkdir(all_cluster_data_folder);
	mkdir(all_lda_data_folder);
	mkdir(all_classification_results_folder);
	mkdir(all_clustering_results_folder);
	mkdir(all_lda_results_folder);
end

labels_filepath = strcat(all_raw_data_folder, 'labels.txt');
labels = load(labels_filepath);

label_users_filepath = strcat(all_raw_data_folder, 'label_users.txt');
label_users = load(label_users_filepath);

unique_labels = unique(labels);

size_file_path = strcat(all_raw_data_folder, 'sizes.txt');
sizes = load(size_file_path);

compressed_labels_filepath = strcat(all_raw_data_folder, 'compressed_labels.txt');
compressed_labels = load(compressed_labels_filepath);

users_file_path = strcat(all_raw_data_folder, 'users.txt');
users = load(users_file_path);

eids_file_path = strcat(all_raw_data_folder, 'eids.txt');
eids = load(eids_file_path);

is_testing_event = zeros(length(labels),1);
for e=1:length(labels)
	if (users(e) == HELD_OUT_USER)
		is_testing_event(e) = 1;
	end
end

labels_is_testing = [];
for e=1:length(labels)
	if is_testing_event(e)
		labels_is_testing = [labels_is_testing; ones(sizes(e),1)];
	else
		labels_is_testing = [labels_is_testing; zeros(sizes(e),1)];
	end
end

compressed_window_labels = [];
for e=1:length(labels)
	compressed_window_labels = [compressed_window_labels; ones(sizes(e),1) * compressed_labels(e)];	
end
compressed_training_window_labels = compressed_window_labels(labels_is_testing==0);
compressed_testing_window_labels = compressed_window_labels(labels_is_testing==1);
