%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%% apply fft on the input data
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;
constants;

%% concat all the events data
for u=1:USER_LENGTH
	build_user_folder;

	for e=1:length(labels)
		disp( strcat('fft', 32, int2str(u), 32, USER_LIST{u}, 32, 'event', 32, int2str(e), ' ...') );
		data_xyz_filepath = strcat(user_raw_data_folder, 'event', int2str(e), '.txt');	
		data_xyz = load(data_xyz_filepath);

		fft_features = [];

		cur_start = 1;
		cur_end = cur_start + WINDOW_SIZE - 1;
		while cur_end <= length(data_xyz)
			window_data = data_xyz(cur_start:cur_end, :);

			fft_combine_xyz = [];
			for d=1:3
				fft_length = pow2(nextpow2(WINDOW_SIZE));
				fft_data = fft(window_data(:,d), fft_length);
				frequencies = (0: fft_length-1) * (PWDATA_SAMPLING_RATE / WINDOW_SIZE);

				fft_data_mag = 2 * abs(fft_data);
				fft_combine_xyz = [fft_combine_xyz fft_data_mag(1:MAX_FREQUENCIES)'];
			end

			fft_features = [fft_features; fft_combine_xyz];

			cur_start = cur_start + WINDOW_SLIDE;
			cur_end = cur_start + WINDOW_SIZE - 1;
		end

		output_file_path = strcat(user_fft_data_folder, 'event', int2str(e), '.txt' );
		save(output_file_path , 'fft_features','-ASCII', '-tabs');
	end
end
