%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;
constants;

build_all_folder;
fft_file_path = strcat(all_raw_data_folder, 'data.txt' );
fft_features = load(fft_file_path);

training = fft_features(label_users ~= HELD_OUT_USER, :);
training_eid = eids(label_users ~= HELD_OUT_USER);
testing = fft_features(label_users == HELD_OUT_USER, :);
testing_eid = eids(label_users == HELD_OUT_USER);

[coefs, scores, variances, t2] = princomp(training);
training_reduced = scores(:, 1:PCA_REDUCED_DIMENSION);

testingCentered = bsxfun(@minus, testing, mean(testing)); % center the test data
testing_reduced = testingCentered * coefs(:, 1:PCA_REDUCED_DIMENSION);

training_eid_file_path = strcat(all_reduced_fft_data_folder, 'training_eid.txt');
testing_eid_file_path = strcat(all_reduced_fft_data_folder, 'testing_eid.txt');
training_file_path = strcat(all_reduced_fft_data_folder, 'training_data.txt');
testing_file_path = strcat(all_reduced_fft_data_folder, 'testing_data.txt');

save(training_file_path, 'training_reduced','-ASCII', '-tabs');
save(testing_file_path, 'testing_reduced','-ASCII', '-tabs');
save(training_eid_file_path, 'training_eid','-ASCII', '-tabs');
save(testing_eid_file_path, 'testing_eid','-ASCII', '-tabs');
