%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%% apply fft on the input data
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;
constants;

%% concat all the events data
for u=1:USER_LENGTH
	build_user_folder;

	disp(strcat('user', int2str(u), 32));

	training_eid = [];
	testing_eid = [];
	training = [];
	testing = [];
	for e=1:length(labels)
		fft_file_path = strcat(user_fft_data_folder, 'event', int2str(e), '.txt' );
		fft_features = load(fft_file_path);

		if is_testing_event(e) == 1
			testing = [testing; fft_features];
			testing_eid = [testing_eid; ones(size(fft_features,1),1) * e];
		else
			training = [training; fft_features];	
			training_eid = [training_eid; ones(size(fft_features,1),1) * e];
		end			
	end

	[coefs, scores, variances, t2] = princomp(training);
	training_reduced = scores(:, 1:PCA_REDUCED_DIMENSION);
	
	testingCentered = bsxfun(@minus, testing, mean(testing)); % center the test data
	testing_reduced = testingCentered * coefs(:, 1:PCA_REDUCED_DIMENSION);

	training_eid_file_path = strcat(user_reduced_fft_data_folder, 'training_eid.txt');
	testing_eid_file_path = strcat(user_reduced_fft_data_folder, 'testing_eid.txt');
	training_file_path = strcat(user_reduced_fft_data_folder, 'training_data.txt');
	testing_file_path = strcat(user_reduced_fft_data_folder, 'testing_data.txt');

	save(training_file_path, 'training_reduced','-ASCII', '-tabs');
	save(testing_file_path, 'testing_reduced','-ASCII', '-tabs');
	save(training_eid_file_path, 'training_eid','-ASCII', '-tabs');
	save(testing_eid_file_path, 'testing_eid','-ASCII', '-tabs');
end
