%%
user_ident_data_folder = strcat(IDENT_DATA_FOLDER, USER_LIST{u}, '/'); 
user_raw_data_folder = strcat(RAW_DATA_FOLDER, USER_LIST{u}, '/');
user_fft_data_folder = strcat(FFT_DATA_FOLDER, USER_LIST{u}, '/');
user_reduced_fft_data_folder = strcat(REDUCED_FFT_DATA_FOLDER, USER_LIST{u}, '/');
user_cluster_data_folder = strcat(CLUSTER_DATA_FOLDER, USER_LIST{u}, '/');
user_lda_data_folder = strcat(LDA_DATA_FOLDER, USER_LIST{u}, '/');
user_classification_results_folder = strcat(CLASSIFICATION_RESULTS_FOLDER, USER_LIST{u}, '/');
user_clustering_results_folder = strcat(CLUSTERING_RESULTS_FOLDER, USER_LIST{u}, '/');
user_lda_results_folder = strcat(LDA_RESULTS_FOLDER, USER_LIST{u}, '/');

if DO_MKDIR
	mkdir(user_raw_data_folder);
	mkdir(user_fft_data_folder);
	mkdir(user_reduced_fft_data_folder);
	mkdir(user_cluster_data_folder);
	mkdir(user_lda_data_folder);
	mkdir(user_classification_results_folder);
	mkdir(user_clustering_results_folder);
	mkdir(user_lda_results_folder);
end

labels_filepath = strcat(user_ident_data_folder, 'labels.txt');
labels = load(labels_filepath);

unique_labels = unique(labels);

size_file_path = strcat(user_raw_data_folder, 'sizes.txt');
size_data = load(size_file_path);

sizes = [];
for e=1:length(size_data)
	sizes = [sizes; floor((size_data(e) - WINDOW_SIZE) / WINDOW_SLIDE) + 1];	
end

compressed_labels = [];
for i=1:length(labels)
	for j=1:length(unique_labels)
		if labels(i) == unique_labels(j)
			compressed_labels = [compressed_labels; j];
		end
	end	
end

%% find out which events are included in the testing set in different validation fold.
%% the answer is put in is_testing_event
%%	If is_testing_event(i, j) = 1, it means that event i is in the testing set of fold j. otherwise, event i is in the training set.
total_appeared = zeros(max(labels),1);
for e=1:length(labels)
	total_appeared(labels(e)) = total_appeared(labels(e)) + 1;
end
appeared = zeros(max(labels),1);
is_testing_event = zeros(length(labels),1);
for e=1:length(labels)
	if total_appeared(labels(e)) < 2
		continue;
	end
	appeared(labels(e)) = appeared(labels(e)) + 1;
	if appeared(labels(e)) == 1
		is_testing_event(e) = 1;
	end
end

labels_is_testing = [];
for e=1:length(labels)
	if is_testing_event(e)
		labels_is_testing = [labels_is_testing; ones(sizes(e),1)];
	else
		labels_is_testing = [labels_is_testing; zeros(sizes(e),1)];
	end
end

compressed_window_labels = [];
for e=1:length(labels)
	compressed_window_labels = [compressed_window_labels; ones(sizes(e),1) * compressed_labels(e)];	
end
compressed_training_window_labels = compressed_window_labels(labels_is_testing==0);
compressed_testing_window_labels = compressed_window_labels(labels_is_testing==1);

