%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;
constants;

build_all_folder;

accuracies_cnt = [];
accuracies_dist = [];
for c=CLUSTERING_SIZE_MIN:CLUSTERING_SIZE_INT:CLUSTERING_SIZE_MAX

	training_data = load(strcat(all_cluster_data_folder, 'c', int2str(c), '_training_event_cluster_count.txt'));
	testing_data = load(strcat(all_cluster_data_folder, 'c', int2str(c), '_testing_event_cluster_count.txt'));

	training_labels = compressed_labels(is_testing_event == 0);
	testing_labels = compressed_labels(is_testing_event == 1);

	do_classify_nn_clusters;

	accuracy = sum(prediction_output(:,1) == prediction_output(:,2)) / length(prediction_output);
	accuracies_cnt = [accuracies_cnt; accuracy];

	training_data = diag(1./sum(training_data,2)) * training_data;
	testing_data = diag(1./sum(testing_data,2)) * testing_data;

	do_classify_nn_clusters;

	accuracy = sum(prediction_output(:,1) == prediction_output(:,2)) / length(prediction_output);
	accuracies_dist = [accuracies_dist; accuracy];	
end

save(strcat(all_clustering_results_folder, 'accuracy_cnt.txt'), 'accuracies_cnt','-ASCII', '-tabs');
save(strcat(all_clustering_results_folder, 'accuracy_dist.txt'), 'accuracies_dist','-ASCII', '-tabs');
