%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;
constants;

build_all_folder;

accuracies = [];
for c=CLUSTERING_SIZE_MIN:CLUSTERING_SIZE_INT:CLUSTERING_SIZE_MAX
	accuracies_t = [];
	for t=TOPIC_SIZE_MIN:TOPIC_SIZE_INT:TOPIC_SIZE_MAX
		disp(strcat('c', int2str(c), 't', int2str(t)));

		training_data = load(strcat(all_lda_data_folder, 'c', int2str(c), 't', int2str(t), '_training.txt'));
		testing_data = load(strcat(all_lda_data_folder, 'c', int2str(c), 't', int2str(t), '_testing.txt'));

		training_labels = compressed_labels(is_testing_event == 0);
		testing_labels = compressed_labels(is_testing_event == 1);

		do_classify_nn_clusters; %% It reads _clusters, but the code also works for lda.
	
		accuracy = sum(prediction_output(:,1) == prediction_output(:,2)) / length(prediction_output);
		accuracies_t = [accuracies_t accuracy];
	end
	accuracies = [accuracies; accuracies_t];
end
save(strcat(all_lda_results_folder, 'accuracies.txt'), 'accuracies','-ASCII', '-tabs');
