%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;
constants;

for u=1:USER_LENGTH
	disp(strcat('user', int2str(u)));

	build_user_folder;

	training_eid_file_path = strcat(user_reduced_fft_data_folder, 'training_eid.txt');
	testing_eid_file_path = strcat(user_reduced_fft_data_folder, 'testing_eid.txt');
	training_file_path = strcat(user_reduced_fft_data_folder, 'training_data.txt');
	testing_file_path = strcat(user_reduced_fft_data_folder, 'testing_data.txt');

	training_data = load(training_file_path);
	training_eids = load(training_eid_file_path);
	testing_data = load(testing_file_path);
	testing_eids = load(testing_eid_file_path);

	training_labels = [];
	for i=1:length(training_eids)
		training_labels = [training_labels; labels(training_eids(i))];
	end
	testing_labels = [];
	for i=1:length(testing_eids)
		testing_labels = [testing_labels; labels(testing_eids(i))];
	end

	predicted_label = [];
	for e=1:length(testing_labels)
		idx = knnsearch(training_data, testing_data(e, :), 'K', 1);
		eIdx = training_labels(idx);
		predicted_label = [predicted_label; mode(eIdx)];
	end		
	prediction_output = [predicted_label testing_labels];

	prediction_output_perevent = [];
	for e=1:length(labels)
		if is_testing_event(e)
			event_prediction_output = prediction_output(testing_eids == e, :);
			pe = mode(event_prediction_output(:,1));
			te = mode(event_prediction_output(:,2));
			prediction_output_perevent = [prediction_output_perevent; pe te];
		end
	end

	perwindow_file_path = strcat(user_classification_results_folder, 'nn_perwindow.txt');
	perevent_file_path = strcat(user_classification_results_folder, 'nn_perevent.txt');

	save(perwindow_file_path, 'prediction_output','-ASCII', '-tabs');
	save(perevent_file_path, 'prediction_output_perevent','-ASCII', '-tabs');
end
