%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;
constants;

%USER_LENGTH = 1;
%CLUSTERING_SIZE_MAX = CLUSTERING_SIZE_MIN;
%TOPIC_SIZE_MAX = TOPIC_SIZE_MIN;

cluster_range = (CLUSTERING_SIZE_MAX-CLUSTERING_SIZE_MIN)/CLUSTERING_SIZE_INT + 1;
topic_range = (TOPIC_SIZE_MAX-TOPIC_SIZE_MIN)/TOPIC_SIZE_INT + 1;

average_accuracies = zeros(cluster_range, topic_range);

for u=1:USER_LENGTH
	disp(strcat('user', int2str(u)));

	build_user_folder;

	accuracies = [];
	for c=CLUSTERING_SIZE_MIN:CLUSTERING_SIZE_INT:CLUSTERING_SIZE_MAX

		accuracies_t = [];
		for t=TOPIC_SIZE_MIN:TOPIC_SIZE_INT:TOPIC_SIZE_MAX
			training_data = load(strcat(user_lda_data_folder, 'c', int2str(c), 't', int2str(t), '_training.txt'));
			testing_data = load(strcat(user_lda_data_folder, 'c', int2str(c), 't', int2str(t), '_testing.txt'));

			training_labels = compressed_labels(is_testing_event == 0);
			testing_labels = compressed_labels(is_testing_event == 1);

			do_classify_nn_clusters; %% It reads _clusters, but the code also works for lda.
		
			accuracy = sum(prediction_output(:,1) == prediction_output(:,2)) / length(prediction_output);
			accuracies_t = [accuracies_t accuracy];
		end
		accuracies = [accuracies; accuracies_t];
	end

	average_accuracies = average_accuracies + accuracies;

	save(strcat(user_lda_results_folder, 'accuracies.txt'), 'accuracies','-ASCII', '-tabs');
end

average_accuracies = average_accuracies / USER_LENGTH;
