%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear;
constants;

build_all_folder;

errors1 = [];
errors2 = [];

for c=CLUSTERING_SIZE_MIN:CLUSTERING_SIZE_INT:CLUSTERING_SIZE_MAX
	disp( strcat('cluster size', 32, int2str(c), ' ...') );
	
	training_eids = load(strcat(all_reduced_fft_data_folder, 'training_eid.txt'));
	testing_eids = load(strcat(all_reduced_fft_data_folder, 'testing_eid.txt'));
	training_data = load(strcat(all_reduced_fft_data_folder, 'training_data.txt'));
	testing_data = load(strcat(all_reduced_fft_data_folder, 'testing_data.txt'));

	[training_IDX, C, sumd, D] = kmeans(training_data, c, 'MaxIter', 1000);
	testing_IDX = knnsearch(C, testing_data);

	training_cluster_path = strcat(all_cluster_data_folder, 'c', int2str(c), '_training.txt');
	testing_cluster_path = strcat(all_cluster_data_folder, 'c', int2str(c), '_testing.txt');

	save(training_cluster_path, 'training_IDX','-ASCII', '-tabs');
	save(testing_cluster_path, 'testing_IDX','-ASCII', '-tabs');

	%% cluster - event type count
	event_cluster_count = zeros(length(labels), c);
	for i=1:length(training_eids)
		event_cluster_count(training_eids(i), training_IDX(i)) = event_cluster_count(training_eids(i), training_IDX(i)) + 1;
	end
	event_cluster_count = event_cluster_count(is_testing_event==0, :);
	event_cluster_count_path = strcat(all_cluster_data_folder, 'c', int2str(c), '_training_event_cluster_count.txt');
	save(event_cluster_count_path, 'event_cluster_count','-ASCII', '-tabs');

	event_cluster_count = zeros(length(labels), c);
	for i=1:length(testing_eids)
		event_cluster_count(testing_eids(i), testing_IDX(i)) = event_cluster_count(testing_eids(i), testing_IDX(i)) + 1;
	end
	event_cluster_count = event_cluster_count(is_testing_event==1, :);
	event_cluster_count_path = strcat(all_cluster_data_folder, 'c', int2str(c), '_testing_event_cluster_count.txt');
	save(event_cluster_count_path, 'event_cluster_count','-ASCII', '-tabs');

	%% Compute Errors
	err1 = sum((grpstats(testing_IDX, testing_IDX, 'numel')-1) .* sum(grpstats(testing_data, testing_IDX, 'var'), 2));
	for d=1:size(testing_data,1)
		dif = testing_data(d,:) - C(testing_IDX(d),:);
		err2 = dif * dif';
	end	
	errors1 = [errors1; err1];
	errors2 = [errors2; err2];
end
