%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear;
constants;

%USER_LENGTH = 1;
%CLUSTERING_SIZE_MAX = CLUSTERING_SIZE_MIN;
CLUSTERING_SIZE_MAX = 15;
CLUSTERING_SIZE_MIN = 15;

for u=1:USER_LENGTH
	disp(strcat('user', int2str(u)));

	build_user_folder;

	errors1 = [];
	errors2 = [];
	purity = [];
	randIndex = [];
	for c=CLUSTERING_SIZE_MIN:CLUSTERING_SIZE_INT:CLUSTERING_SIZE_MAX
		disp( strcat('cluster size', 32, int2str(c), ' ...') );
		
		training_eid_file_path = strcat(user_reduced_fft_data_folder, 'training_eid.txt');
		testing_eid_file_path = strcat(user_reduced_fft_data_folder, 'testing_eid.txt');
		training_file_path = strcat(user_reduced_fft_data_folder, 'training_data.txt');
		testing_file_path = strcat(user_reduced_fft_data_folder, 'testing_data.txt');
		training_eids = load(training_eid_file_path);
		testing_eids = load(testing_eid_file_path);
		training_data = load(training_file_path);
		testing_data = load(testing_file_path);

		[training_IDX, C, sumd, D] = kmeans(training_data, c, 'MaxIter', 1000);
		testing_IDX = knnsearch(C, testing_data);

		training_cluster_path = strcat(user_cluster_data_folder, 'c', int2str(c), '_training.txt');
		testing_cluster_path = strcat(user_cluster_data_folder, 'c', int2str(c), '_testing.txt');

		save(training_cluster_path, 'training_IDX','-ASCII', '-tabs');
		save(testing_cluster_path, 'testing_IDX','-ASCII', '-tabs');
	
		%% cluster - event type count (Training)
		event_cluster_count = zeros(length(labels), c);
		for i=1:length(training_eids)
			event_cluster_count(training_eids(i), training_IDX(i)) = event_cluster_count(training_eids(i), training_IDX(i)) + 1;
		end
		event_cluster_count = event_cluster_count(is_testing_event==0, :);
		event_cluster_count_path = strcat(user_cluster_data_folder, 'c', int2str(c), '_training_event_cluster_count.txt');
		save(event_cluster_count_path, 'event_cluster_count','-ASCII', '-tabs');

		%% cluster - event type count (Testing)
		event_cluster_count = zeros(length(labels), c);
		for i=1:length(testing_eids)
			event_cluster_count(testing_eids(i), testing_IDX(i)) = event_cluster_count(testing_eids(i), testing_IDX(i)) + 1;
		end
		event_cluster_count = event_cluster_count(is_testing_event==1, :);
		event_cluster_count_path = strcat(user_cluster_data_folder, 'c', int2str(c), '_testing_event_cluster_count.txt');
		save(event_cluster_count_path, 'event_cluster_count','-ASCII', '-tabs');

		%% cluster - event type count (Training + Testing)
		event_cluster_count = zeros(length(labels), c);
		for i=1:length(training_eids)
			event_cluster_count(training_eids(i), training_IDX(i)) = event_cluster_count(training_eids(i), training_IDX(i)) + 1;
		end
		for i=1:length(testing_eids)
			event_cluster_count(testing_eids(i), testing_IDX(i)) = event_cluster_count(testing_eids(i), testing_IDX(i)) + 1;
		end		
		event_cluster_count_path = strcat(user_cluster_data_folder, 'c', int2str(c), '_combine_event_cluster_count.txt');
		save(event_cluster_count_path, 'event_cluster_count','-ASCII', '-tabs');

		%% Compute Errors
		err1 = sum((grpstats(testing_IDX, testing_IDX, 'numel')-1) .* sum(grpstats(testing_data, testing_IDX, 'var'), 2));
		for d=1:size(testing_data,1)
			dif = testing_data(d,:) - C(testing_IDX(d),:);
			err2 = dif * dif';
		end	
		errors1 = [errors1; err1];
		errors2 = [errors2; err2];
	end
end
