%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear;
constants;

%USER_LENGTH = 1;
%CLUSTERING_SIZE_MAX = CLUSTERING_SIZE_MIN;
CLUSTERING_SIZE_MAX = 40;
CLUSTERING_SIZE_MIN = 40;
%DOC_SIZE_MIN = 20;
%DOC_SIZE_MAX = 20;

USER_LENGTH = 1;

for u=1:USER_LENGTH
	disp(strcat('user', int2str(u)));

	build_user_folder;

	training_eid_file_path = strcat(user_reduced_fft_data_folder, 'training_eid.txt');
	testing_eid_file_path = strcat(user_reduced_fft_data_folder, 'testing_eid.txt');
	training_file_path = strcat(user_reduced_fft_data_folder, 'training_data.txt');
	testing_file_path = strcat(user_reduced_fft_data_folder, 'testing_data.txt');
	training_eids = load(training_eid_file_path);
	testing_eids = load(testing_eid_file_path);
	training_data = load(training_file_path);
	testing_data = load(testing_file_path);

	combine_data = [];
	cur_training = 1;
	cur_testing = 1;
	for e=1:length(labels)
		if is_testing_event(e)
			combine_data = [combine_data; testing_data(cur_testing: cur_testing + sizes(e) - 1, :)];
			cur_testing = cur_testing + sizes(e);
		else
			combine_data = [combine_data; training_data(cur_training: cur_training + sizes(e) - 1, :)];
			cur_training = cur_training + sizes(e);			
		end
	end
	
	for c=CLUSTERING_SIZE_MIN:CLUSTERING_SIZE_INT:CLUSTERING_SIZE_MAX
		[IDX, C, sumd, D] = kmeans(combine_data, c, 'MaxIter', 1000);
	
		%% event as document
		event_cluster_count = [];
		cur_idx = 1;
		for e=1:length(labels)
			cluster_count = zeros(1, c);
			for i=1:sizes(e)
				cluster_count(1, IDX(cur_idx)) = cluster_count(1, IDX(cur_idx)) + 1;
				cur_idx = cur_idx + 1;
			end
			event_cluster_count = [event_cluster_count; cluster_count];
		end

		event_cluster_count_path = strcat(user_cluster_data_folder, 'c', int2str(c), '_combine_event_cluster_count.txt');
		save(event_cluster_count_path, 'event_cluster_count','-ASCII', '-tabs');

		for d=DOC_SIZE_MIN:DOC_SIZE_INT:DOC_SIZE_MAX
			disp( strcat('cluster size', 32, int2str(c), 32, 'd', int2str(d), ' ...') );

			doc_cluster_count = [];
			cur_idx = 1;
			for e=1:length(labels)
				next_start = cur_idx + sizes(e) - 1;

				while cur_idx + d - 1 < next_start
					cluster_count = zeros(1, c);
					for i=1:d
						cluster_count(1, IDX(cur_idx)) = cluster_count(1, IDX(cur_idx)) + 1;
						cur_idx = cur_idx + 1;
					end
					doc_cluster_count = [doc_cluster_count; cluster_count];
				end
				cur_idx = next_start;
			end

			doc_cluster_count_path = strcat(user_cluster_data_folder, 'c', int2str(c), 'd', int2str(d), '_combine_doc_cluster_count.txt');
			save(doc_cluster_count_path, 'doc_cluster_count','-ASCII', '-tabs');			
		end
	end
end
