%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;
constants;

all_raw_data_folder = strcat(RAW_DATA_FOLDER, 'all', '/');
all_fft_data_folder = strcat(FFT_DATA_FOLDER, 'all', '/');

mkdir(all_raw_data_folder);
mkdir(all_fft_data_folder);

discard_labels = [350; 420; 1010]; %% they have less than 3 trials in total

cur_eid = 1;
combine_eids = [];
combine_data = [];
combine_users = [];
all_labels = [];
all_sizes = [];
all_users = [];

for u=1:USER_LENGTH
	build_user_folder;
	
	for i=1:length(labels)
		if any(discard_labels == labels(i)) == 1 
			continue;
		end

		len = floor((size_data(i) - WINDOW_SIZE) / WINDOW_SLIDE) + 1;	

		all_sizes = [all_sizes; len];		
		all_labels = [all_labels; labels(i)];
		all_users = [all_users; u];

		file_path = strcat(user_fft_data_folder, 'event', int2str(i), '.txt');

		data = load(file_path);
		combine_users = [combine_users; ones(size(data,1),1) * u];
		combine_data = [combine_data; data];
		combine_eids = [combine_eids; ones(size(data,1),1) * cur_eid];
		cur_eid = cur_eid + 1;	
	end
end

all_unique_labels = unique(all_labels);

all_compressed_labels = [];
for i=1:length(all_labels)
	for j=1:length(all_unique_labels)
		if all_labels(i) == all_unique_labels(j)
			all_compressed_labels = [all_compressed_labels; j];
		end
	end	
end

event_count = zeros(length(all_unique_labels), USER_LENGTH);
for i=1:length(all_labels)
	event_count(all_compressed_labels(i), all_users(i)) = event_count(all_compressed_labels(i), all_users(i)) + 1;
end

event_count_filepath = strcat(all_raw_data_folder, 'event_count_summary.txt');
save(event_count_filepath , 'event_count','-ASCII', '-tabs');

data_filepath = strcat(all_raw_data_folder, 'data.txt');
save(data_filepath , 'combine_data','-ASCII', '-tabs');

eids_filepath = strcat(all_raw_data_folder, 'eids.txt');
save(eids_filepath , 'combine_eids','-ASCII', '-tabs');

label_users_filepath = strcat(all_raw_data_folder, 'label_users.txt');
save(label_users_filepath , 'combine_users','-ASCII', '-tabs');

labels_filepath = strcat(all_raw_data_folder, 'labels.txt');
save(labels_filepath , 'all_labels','-ASCII', '-tabs');

compressed_labels_filepath = strcat(all_raw_data_folder, 'compressed_labels.txt');
save(compressed_labels_filepath , 'all_compressed_labels','-ASCII', '-tabs');

sizes_filepath = strcat(all_raw_data_folder, 'sizes.txt');
save(sizes_filepath , 'all_sizes','-ASCII', '-tabs');

users_filepath = strcat(all_raw_data_folder, 'users.txt');
save(users_filepath , 'all_users','-ASCII', '-tabs');
