%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;
constants;

build_all_folder;

accuracies_cnt = [];
accuracies_dist = [];
c = 40;

training_data = load(strcat(all_cluster_data_folder, 'c', int2str(c), '_training_event_cluster_count.txt'));
testing_data = load(strcat(all_cluster_data_folder, 'c', int2str(c), '_testing_event_cluster_count.txt'));

training_labels = compressed_labels(is_testing_event == 0);
testing_labels = compressed_labels(is_testing_event == 1);

training_data = diag(1./sum(training_data,2)) * training_data;
testing_data = diag(1./sum(testing_data,2)) * testing_data;

do_classify_nn_clusters;

accuracy = sum(prediction_output(:,1) == prediction_output(:,2)) / length(prediction_output);
accuracies_dist = [accuracies_dist; accuracy];

confusion = zeros(length(unique_labels), length(unique_labels));
for i=1:length(prediction_output)
	confusion(prediction_output(i,2), prediction_output(i,1)) = confusion(prediction_output(i,2), prediction_output(i,1)) + 1;
end

