%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%% This file defines all constants and file paths   
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% experiments results folder path.
CORE_DATA_FOLDER 	= 'experiment/';
PWDATA_FOLDER 		= strcat('../WSTdata/');
IDENT_DATA_FOLDER 	= strcat(CORE_DATA_FOLDER, 'identified_data/');  			
RAW_DATA_FOLDER 	= strcat(CORE_DATA_FOLDER, 'raw_data/');
FFT_DATA_FOLDER 	= strcat(CORE_DATA_FOLDER, 'fft_data/');
REDUCED_FFT_DATA_FOLDER = strcat(CORE_DATA_FOLDER, 'reduced_fft_data/');
CLUSTER_DATA_FOLDER	= strcat(CORE_DATA_FOLDER, 'cluster_data/');
LDA_DATA_FOLDER		= strcat(CORE_DATA_FOLDER, 'lda_data/');

CLASSIFICATION_RESULTS_FOLDER = strcat(CORE_DATA_FOLDER, 'classification_results/');
CLUSTERING_RESULTS_FOLDER = strcat(CORE_DATA_FOLDER, 'clustering_results/');
LDA_RESULTS_FOLDER = strcat(CORE_DATA_FOLDER, 'lda_results/');

LDA_DATA_FOLDER		= strcat(CORE_DATA_FOLDER, 'lda_data/');
LDA_SPLIT_DATA_FOLDER	= strcat(CORE_DATA_FOLDER, 'lda_split_data/');
PERPLEXITIES_RESULTS_FOLDER		= strcat(CORE_DATA_FOLDER, 'perplexities_results/');
ALL_PATIENTS_FOLDER	= strcat(CORE_DATA_FOLDER, 'all_patients/');

DO_MKDIR = false;  % if all folder is built, then disable this.

JUST_CLUSTER_DATA_FOLDER = strcat(CORE_DATA_FOLDER, 'just_cluster_data/');
CLUSTER_SIZE_RESULT_FOLDER = strcat(CORE_DATA_FOLDER, 'cluster_size_result/');

%% The raw data sampling rate.
PWDATA_SAMPLING_RATE = 250;

USER_LIST = {'angela', 'catherine', 'denise',  'Ginette', 'jacqueline', 'jessica',  'nahid'};
USER_LENGTH = size(USER_LIST, 2);

%% libsvm directory
LIBSVM_DIR = 'libsvm-3.14/matlab/';
LIBSVM_DIR_BACK = '../../';

%% topic modelling toolbox directory
addpath('/home/ml/hyuen/Documents/courses/machine learning/project/ws_code/topictoolbox');

%% FFT settings
WINDOW_SIZE = 500; %% 2 seconds
WINDOW_SLIDE = 50;
SAMPLING_PERIOD = 1/PWDATA_SAMPLING_RATE;
MAX_FREQUENCIES = 50;
PCA_REDUCED_DIMENSION = 10;

%% CLUSTER/ TOPIC grid
CLUSTERING_SIZE_MIN = 10;
CLUSTERING_SIZE_MAX = 100;
CLUSTERING_SIZE_INT = 10;

TOPIC_SIZE_MIN = 5;
TOPIC_SIZE_MAX = 25;
TOPIC_SIZE_INT = 5;

DOC_SIZE_MIN = 5;
DOC_SIZE_MAX = 30;
DOC_SIZE_INT = 5;

%% VALIDATION_FOLD
VALIDATION_FOLD = 2;

HELD_OUT_USER = 1;

%% Temporarily, just run experients on angela's dataset.
% USER_LIST = {'angela'};
% USER_LENGTH = size(USER_LIST, 2);

DISCARD_EVENT_TYPES = [350; 420; 1010]; %% they have less than 3 trials.

