%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%% Extract acceleration X,Y,Z from WST Data  
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear;
constants;

for u=1:USER_LENGTH
	user_ident_data_folder = strcat(IDENT_DATA_FOLDER, USER_LIST{u}, '/'); 
	user_raw_data_folder = strcat(RAW_DATA_FOLDER, USER_LIST{u}, '/');
	mkdir(user_raw_data_folder);
	
	labels_filepath = strcat(user_ident_data_folder, 'labels.txt');
	labels = load(labels_filepath);
	unique_labels = unique(labels);

	sizes = [];
	for e=1:length(labels)
		data_filepath = strcat(user_ident_data_folder, 'event', int2str(e), '.dat');
		fid = fopen(data_filepath,'r','b');
		data = fread(fid,[18,inf],'int16')';
		fclose(fid);

		% Paramtres du filtre
		Fc = 50;
		Fe = 250;
		Wn = Fc/Fe;
		[B,A] = butter(2,Wn,'low');
	
		% Filtrage
		% columns 5, 6, 7 are acceration x, y, z respectively
		acc_data = data(:,[5 6 7]);
		t = [0:1/Fe:(length(acc_data)-1/Fe)/Fe]';
		acc_data = filtfilt(B,A,acc_data);
	
		% Mise  l'chelle des signaux d'acclration
		acc_data(:,1) = ((acc_data(:,1)*5/2048)-2.5)*2;
		acc_data(:,2) = ((acc_data(:,2)*5/2048)-2.5)*2;
		acc_data(:,3) = ((acc_data(:,3)*5/2048)-2.5)*2;

		save( strcat(user_raw_data_folder, 'event', int2str(e), '.txt') , 'acc_data', '-ASCII', '-tabs');
		sizes = [sizes; size(data,1)];
	end

	save( strcat(user_raw_data_folder, 'labels.txt') , 'labels', '-ASCII', '-tabs');
	save( strcat(user_raw_data_folder, 'sizes.txt') , 'sizes', '-ASCII', '-tabs');
end
